#!/usr/bin/env bash
# Description: Log Generator
# Copyright (C) 2012-2021 Eduardo Moraes <emoraes25@gmail.com>
# This file is part of CID (Closed In Directory).
#
# CID is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# CID is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with CID.  If not, see <http://www.gnu.org/licenses/>.
#------------------------------------------------------------------------#


. ${0%/*}/vars.bash

[ $LOGSIZE -eq 0 ] && exit 0

if [ -f "$1" ]; then

	if [ "$(cat "$1")" ]; then
		cd $LOGDIR

		[ -f "$2" -o "$(echo $2 | grep -Ew "CID Init Script >> (start|reload)")" ] && file='Scripts.log' || file='Functions.log'

		sed -i '/^$/d;s/^/\t/g' "$1"

		if [ ! -f ${file,} ]; then
			>${file,} && chmod 600 ${file,}
		else
            LOGSIZE=${LOGSIZE:=1000}
			[ $(wc -l ${file,} | awk '{print $1}') -ge $LOGSIZE ] && int=$(($(find -name '${file,}*.tar.gz' | wc -l)+1)) && tar -czf ${file,}.${int}.tar.gz ${file,} && rm -f ${file,}
		fi

		echo "$(date "+%G-%m-%d %T - ${file%.*}: $2 - Status: $3 - Output:")
$(cat "$1")
------------------------------------------------" >> ${file,}

		unset file
		cd - > /dev/null
	fi

	rm -f "$1"
fi

exit 0