#!/usr/bin/env bash
# Description: Pre-Logon Script (Run with root id)
# Copyright (C) 2012-2021 Eduardo Moraes <emoraes25@gmail.com>
# This file is part of CID (Closed In Directory).
#
# CID is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# CID is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with CID.  If not, see <http://www.gnu.org/licenses/>.
#------------------------------------------------------------------------#


[ "$PAM_TYPE" = "open_session" ] || exit 0

. ${0%/*}/vars.bash

Logon_Variables "$PAM_USER" ; [ $? -eq 0 ] || exit 0

${0%/*}/mkhomedir.bash "$USERPROFILE" ${USERNAME#*\\} "${USERGROUP#*\\}" $USERDOMAIN > "$TEMPFILE" 2>&1
${0%/*}/logger.bash "$TEMPFILE" "${0%/*}/mkhomedir.bash" $?

wbinfo -P > "$TEMPFILE" 2>&1 ; status=$?
${0%/*}/logger.bash "$TEMPFILE" "$0" $status

if [ $status -eq 0 ]; then
	${0%/*}/manager_systemGroups.bash "$USERNAME" > "$TEMPFILE" 2>&1
	${0%/*}/logger.bash "$TEMPFILE" "${0%/*}/manager_systemGroups.bash" $?
fi

if [ ! "$(echo $MODO | grep -w 4)" ]; then
	if [ $status -eq 0 ]; then
		[ "$(command -v setenforce)" ] && setenforce 0

		cp -fv ${VARLIBDIR}/mount_netlogon.xml "$MOUNTFILE" > "$TEMPFILE" 2>&1
		${0%/*}/logger.bash "$TEMPFILE" "$0" $?
	else
		echo '<pam_mount>
	<debug enable="0" />
	<mkmountpoint enable="0" remove="false" />
		<!-- NETLOGON Offline -->
	<logout wait="0" hup="0" term="0" kill="0" />
</pam_mount>' > "$MOUNTFILE"
	fi
fi

Logon_Variables "$PAM_USER" false

exit 0